#ifndef XrayEventDisplayProcessor_h
#define XrayEventDisplayProcessor_h 1

#include "GridPixXrayObject.h"

//c++
#include <string>
#include <vector>
#include <sstream>

//lcio
#include <lcio.h>
#include <EVENT/LCCollection.h>
#include <IMPL/LCCollectionVec.h>
#include <EVENT/LCRelation.h>
#include <IMPL/LCRelationImpl.h>
#include <EVENT/TrackerHit.h>
#include <EVENT/TrackerData.h>

//marlin
#include <marlin/Processor.h>
#include <marlin/Global.h>

//root
#include "TH2D.h"

// Aida
#include <AIDA/AIDA.h>
#include <marlin/AIDAProcessor.h>

namespace marlintpc{

class XrayEventDisplayProcessor;

class XrayEventDisplayProcessor : public marlin::Processor{

public:

	virtual Processor* newProcessor() {return new XrayEventDisplayProcessor;}

	XrayEventDisplayProcessor();

	~XrayEventDisplayProcessor();

	void addHitToEventDisplay(lcio::TrackerHit* hit);

	void addHitToOccupancy(lcio::TrackerHit* hit);

	virtual void init();

	virtual void processRunHeader( lcio::LCRunHeader* run );

	virtual void processEvent( LCEvent * evt );

	virtual void end();

protected:

	std::string _inputCollection;

	TH2D* _occupancy;
	TH2D* _eventDisplay;

	int _numberDisplays;

};//class

}//namespace marlintpc

#endif
