#ifndef XrayGeometryAnalysisProcessor_h
#define XrayGeometryAnalysisProcessor_h 1

#include "GridPixXrayObject.h"
#include "XrayGeometryService.h"

//c++
#include <string>
#include <vector>

//lcio
#include <lcio.h>
#include <EVENT/LCRelation.h>
#include <EVENT/LCCollection.h>
#include <IMPL/LCCollectionVec.h>

//marlin
#include <marlin/Processor.h>

//root
#include <TH1D.h>
#include <TH2D.h>

namespace marlintpc{
  
  class XrayGeometryAnalysisProcessor;
  
  class XrayGeometryAnalysisProcessor : public marlin::Processor{
    
    public:
      
      virtual Processor* newProcessor(){ return new XrayGeometryAnalysisProcessor; }
      
      XrayGeometryAnalysisProcessor();
      
      ~XrayGeometryAnalysisProcessor();
      
      virtual void init();
      
      virtual void processEvent( lcio::LCEvent* evt );
      
      virtual void end();
      
    protected:
      
      std::string _inputCol;
      
      //std::string _inputXrays;
      //std::string _inputHits;
      
      XrayGeometryService* _geoService;
      
      std::vector<TH1D*> _histoVec;
      
      std::vector<TH2D*> _scatterVec;
      
  };//class XrayGeometryAnalysisProcessor
  
}//namespace marlintpc

#endif