#ifndef XrayGeometryService_h
#define XrayGeometryService_h 1

//LCIO
#include <lcio.h>
#include <EVENT/TrackerHit.h>
#include <EVENT/TrackerData.h>
#include <EVENT/LCObject.h>

//marlin
#include <marlin/Global.h>

//C++
#include <iostream>
#include <string>
#include <cmath>
#include <list>
#include <utility>

namespace marlintpc{

  class XrayGeometryService{
  
    public:
      
      //constructor
      XrayGeometryService();
  
      //destructor
      ~XrayGeometryService();
      
      void calculateGeometry(lcio::TrackerHit* hit, double rotAngle);
  
      double getRmsX() const;
      
      double getRmsY() const;
      
      double getLength() const;
      
      double getWidth() const;
      
      double getSkewnessL() const;
      
      double getSkewnessT() const;
      
      double getKurtosisL() const;
      
      double getKurtosisT() const;
      
      double getRadius() const;
      
      double getExcentricity() const;
      
      int numberPixelsWithinRadius(double radius) const;

    private:
      
      double* _memory;

      std::list<std::pair<double,double> > _pixelPositions;
  
  };//class XrayGeometryService
  
}//namespace marlintpc

#endif
