#include <cstdarg>
#include <sstream>
#include <iostream>
#include "TROOT.h"


/*How to call this
 * .L $MARLINTPC/analysis/rootscripts/ProcessAllAnalyses.C++
ProcessAllAnalyses("path for output","path to the aida file", number of runs in the following list, list of the runs)
e.g ProcessAllAnalyses("../myplots","../AidaFiles/",3,18850,18851,18860)
*/
void ProcessAllAnalyses(char * pathToOutput,char * pathToAida, int nRuns, ...){

	std::stringstream parameters;
	parameters<<"(\""<<pathToOutput<<"\",\""<<pathToAida<<"\","<<nRuns;
	va_list argList;
	va_start(argList, nRuns);
	for (int i=0;i<nRuns;i++)
	{
		parameters<<","<<va_arg(argList,int);

	}
	va_end(argList);
	parameters<<")";
	gROOT->ProcessLine(Form("%s%s","AnalysisCutSelector",parameters.str().c_str()));
	gROOT->ProcessLine(Form("%s%s","ChargeQuality",parameters.str().c_str()));
	gROOT->ProcessLine(Form("%s%s","HitQuality",parameters.str().c_str()));
	gROOT->ProcessLine(Form("%s%s","TrackHitEfficiency",parameters.str().c_str()));
	gROOT->ProcessLine(Form("%s%s","DistortionPerformance",parameters.str().c_str()));
	gROOT->ProcessLine(Form("%s%s","TrackParametersDistribution",parameters.str().c_str()));
	gROOT->ProcessLine(Form("%s%s","ResolutionPerformance",parameters.str().c_str()));
	gROOT->ProcessLine(Form("%s%s","TripletResolutionPerformance",parameters.str().c_str()));
	gROOT->ProcessLine(Form("%s%s","PRFPerformance",parameters.str().c_str()));


}
