/* 
 * ModuleDistortionCalculator.hh 
 *
 *  Created on: June 4, 2013
 *      Author: amunnich
 */

#ifndef MODULEDISTORIONCALCULATOR
#define MODULEDISTORIONCALCULATOR

#include<utility>
#include "lcio.h"
#include <EVENT/TrackerHit.h>
#include <EVENT/Track.h>
#include "TH1.h"

// GEAR
namespace gear
{
class TPCParameters;
}

namespace  marlintpc
{
  /**
   * Class to calculate distortions per row along the row
   */
  class ModuleDistortionCalculator
  {
  public:
    /** Calculate the distortion per row, along the row, or in xy, or z
     * GEAR information is needed to do this.
    */
    ModuleDistortionCalculator(const gear::TPCParameters* tpcParameters);
                                    
    /**
     * Virtual destructor
     */
    virtual ~ModuleDistortionCalculator(){}
    /** Calculate the distortion per row along the row projection for a hit and a given track. */
    double calculateDistanceRow(lcio::TrackerHit *hit, lcio::Track *track);

    /** Calculate the distortion per row in the xy plane for a hit and a given track. */ 
    double calculateDistanceXY(lcio::TrackerHit *hit, lcio::Track *track);
  
    /** Calculate the distortion per row in the z plane for a hit and a given track. */ 
    double calculateDistanceZ(lcio::TrackerHit *hit, lcio::Track *track);
     
  private:
    ///default constructor: disabled
    ModuleDistortionCalculator();

    const gear::TPCParameters* _GearParameters;
  };
  
}

#endif //MODULEDISTORIONCALCULATOR
