#ifndef MMPULSESHAPEFUNCTION_H 
#define MMPULSESHAPEFUNCTION_H 

#include <TMath.h>

namespace marlintpc
{

	class MMPulseShapeFunction {

		public:

			MMPulseShapeFunction() {;}

			double pulse_shape(double *time, double *par) {


				// electronic shape function to fit MM pulse shape

				double func_electronic,dtsbeta,variable,puiss;

				double fFunc_max = par[0];
				double fAlpha    = par[1];
				double fTime_max = par[2];
				double fBeta     = par[3];

				double albet = fAlpha*fBeta ;

				if( albet <= 0 ) return( (double)0. );
				double dt = time[0]-fTime_max ;
				if(dt > -albet)  {
					dtsbeta=dt/fBeta ;
					variable=1.+dt/albet ;
					puiss=TMath::Power(variable,fAlpha);
					func_electronic=fFunc_max*puiss*TMath::Exp(-dtsbeta);
				}
				else func_electronic = 0. ;

				return func_electronic ;

			}

	};
}
#endif 

