#ifndef KALTRACKINGBASE_H
#define KALTRACKINGBASE_H

#include <list>
#include <EVENT/Track.h>
#include <EVENT/LCCollection.h>

namespace marlintpc
{

/** This is a base KalDet tracking class. It provides common methods for tracking.
 *
 *  @author Bo Li, Tsinghua University
 *  @author Keisuke Fujii, KEK
 */
class KalTrackingBase
{
   public:
        KalTrackingBase(){}
	virtual ~KalTrackingBase(){}

	/**  Find all possible tracks in the given hit collection
	 */
	virtual std::list<EVENT::Track*>  findTracks(EVENT::LCCollection const * hitCollection) = 0;

        /** Get which type this track is, helix or straight line.
         */
        virtual int getType() = 0;

 private:
        KalTrackingBase(const KalTrackingBase& orig);
      
        KalTrackingBase& operator = (const KalTrackingBase& orig);
};

}
#endif  //KALTRACKINGBASE_H
