/*
 * TEventBlock_V46.cpp
 *
 *  Created on: Jul 10, 2012
 *      Author: caiazza
 */

#include "TIEventBlock.hh"
#include <map>
#include <string>
#include <sstream>

//LCIO
#include "IMPL/LCEventImpl.h"

namespace marlintpc
{
TEventBlock_V46::TEventBlock_V46(std::vector<uint32_t>& Content):
        TEventBlock_V42(Content)
{
    SetRCUDataStart(9);
}

TEventBlock_V46::~TEventBlock_V46()
{

}

lcio::LCTime
TEventBlock_V46::GetTimestamp() const
{
    // lcio::LCTime time(static_cast<EVENT::long64>(Content()[7]));
    //  Content()[7] is in units of seconds as unix time, therefore constructor with int unix time needs be used

    //In this version of the electronics the run header is read out by using timeofday, so it
    //depends on the system clock of the daq machine. The time stamp of the event uses unix time.
    //This causes the runheader to produce a time that is 2h later than the first event causing trouble 
    //for filling the data base.
    //Tried shifting the timestamp of the event by 2h to match time zone of run header.
    //ns precision for timestamp not working with the different clock shemes,  
    //Solution for next time: use unix time for all times recorded by the electronics

    //lcio::LCTime time(static_cast<int>(Content()[7]+2*60*60));
    // time +=  Content()[8];

    //Solution for now: use timestamp from ddbox like in version 42
    lcio::LCTime time(static_cast<EVENT::long64>(Content()[5]));
    //  std::cout<<time.timeStamp()<<" "<<time.hour()<<" "<<time.min()<<" "<<time.sec()<<" "<<time.ns()<<std::endl;
    return time;
}

}
