/*
 * TSORBlock_V47.cpp
 *
 *  Created on: Nov 14, 2012
 *      Author: amunnich
 */

#include "TISORBlock.hh"
#include <map>
#include <string>
#include <sstream>

namespace marlintpc
{

TSORBlock_V47::TSORBlock_V47(std::vector<uint32_t>& Content):
        TSORBlock_V46(Content)
{
  if(!CheckIntegrity())
    {
        std::stringstream message;
        message << "Failed integrity check while analyzing the Start of Run Block" << std::endl;
        throw TAltroConverterDecodeException("TSORBlock_V47", message.str());
    }
    
    //main content is the same as for version 4.6
   std::vector<uint32_t> BlockContent = TSORBlock_V46::Content();
   //now we override the start of run time with the new unix time element
   //first argument: unix time in seconds, second argument in ns
    UTIL::LCTime time(static_cast<int>(BlockContent[10]));
    time +=  BlockContent[11];
    TSORBlock_V42::SetRunStart( time );
    //  std::cout<<"RUNSTART: "<<time.timeStamp()<<" "<<time.getDateString()<<std::endl;
}

TSORBlock_V47::~TSORBlock_V47()
{

}


}//end namespace


