/*
 * EORBlock.hh
 *
 *  Created on: Jul 25, 2011
 *      Author: caiazza
 */

#ifndef EORBLOCK_HH_
#define EORBLOCK_HH_

#include "AltroBlocksLib.h"

namespace A2Lconverter
{
class EORBlock : public AltroBlock
{

public:
    /**
     * From stream constructor that works as a default as well
     */
    EORBlock(std::ifstream* const inputFile=0);
    EORBlock(std::ifstream* const inputFile, int start_address,
            uint32_t length = 0);

    /**
     * Construct the derived class from an instance of the mother class
     */
    EORBlock(const AltroBlock & theMotherBlock);

    /**
     * Construct the class from the data vector
     */
    EORBlock(const std::vector<uint32_t> & refContent);

    /**
     * Destructor
     */
    virtual ~EORBlock()
    {
    }

    /**
     * Derived class implementation of the decode function
     */
    virtual void
    Decode();

    /**
     * Derived class implementation of the writer function
     */
    virtual void
    Write2LCIO(IO::LCWriter* lcwriter) const {}

    /**
     * Derived class implementation of the printer function
     */
    virtual std::string
    PrintSummary() const;

    /**
     * Derived class implementation of the Check Integrity function
     */
    virtual bool
    CheckIntegrity() const;

    /**
     * Function to retrieve the total number of events in the run
     */
    uint32_t GetTotEvents() const;

protected:
    uint32_t totEvents;
};
}

#endif /* EORBLOCK_HH_ */
