/*
 * EventBlock.hh
 *
 *  Created on: Jul 26, 2011
 *      Author: caiazza
 */

#ifndef EVENTBLOCK_HH_
#define EVENTBLOCK_HH_

#include "AltroBlocksLib.h"

namespace A2Lconverter
{
class EventBlock : public AltroBlock
{
public:

    static EVENT::long64 tstampSkip;
    static EVENT::long64 baseTStamp;

    /**
     * From stream constructor that works as a default as well
     */
    EventBlock(std::ifstream* const inputFile=0);
    EventBlock(std::ifstream* const inputFile, int start_address,
            uint32_t length = 0);

    /**
     * Construct the derived class from an instance of the mother class
     */
    EventBlock(const AltroBlock & theMotherBlock);

    /**
     * Construct the class from the data vector
     */
    EventBlock(const std::vector<uint32_t> & refContent);

    /**
     * Destructor
     */
    virtual ~EventBlock()
    {
    }

    /**
     * Derived class implementation of the decode function
     */
    virtual void
    Decode();

    /**
     * Derived class implementation of the writer function
     */
    virtual void
    Write2LCIO(IO::LCWriter* lcwriter) const;

    /**
     * Derived class implementation of the printer function
     */
    virtual std::string
    PrintSummary() const;

    /**
     * Derived class implementation of the Check Integrity function
     */
    virtual bool
    CheckIntegrity() const;

protected:
    uint32_t eventNr;
    static uint32_t eventsRead;

    uint32_t DBOXEVTN;
    uint32_t DBOXTIME;
    uint32_t TLUEVTN;

    std::vector<RCUBlock> Data;
};
}




#endif /* EVENTBLOCK_HH_ */
