
// stl
#include <string>
#include <cassert>

// LCIO
#include <EVENT/LCCollection.h>
#include <EVENT/LCGenericObject.h>

// Marlin
#include <marlin/Global.h>

// GEAR
#include <gear/BField.h>
#include <gearimpl/Vector3D.h>

// marlintpc
#include "GEARMagneticField.h"

using namespace CLHEP;
using namespace EVENT;
using namespace std;
using namespace gear;

namespace marlintpc {

GEARMagneticField aGEARMagneticField;

/** constructor
 */
GEARMagneticField::GEARMagneticField():
	Field("GEARMagneticField") {
}


/** destructor
 */
GEARMagneticField::~GEARMagneticField() {}


/** returns a new field... similar to how the Marlin processor registration works
*/
Field *GEARMagneticField::new_field( void ) { return new GEARMagneticField; }


/** constructs the field from an LCCollection of data objects (could be anything... field bin values or just parameters)
*/
bool GEARMagneticField::construct( LCCollection * /*collection*/ ) {

	return true;
}


/** gets the field value at a specified point
*/
CLHEP::Hep3Vector GEARMagneticField::get_field_value( const CLHEP::Hep3Vector &position ) {

	CLHEP::Hep3Vector field_vector = CLHEP::Hep3Vector();

	Vector3D gear_position(position[0], position[1], position[2]);

	const Vector3D gear_field = marlin::Global::GEAR->getBField().at(gear_position);

	field_vector.set(gear_field.x(), gear_field.y(), gear_field.z());

	return field_vector;
}

} // namespace marlintpc
