##############################################################################
# cmake configuration file for TPCCondData
#
# returns following variables:
#
#   TPCCondData_FOUND      : set to TRUE if TPCCondData found
#   TPCCondData_VERSION    : package version
#   TPCCondData_ROOT       : path to this TPCCondData installation
#   TPCCondData_LIBRARIES  : list of TPCCondData libraries
#   TPCCondData_INCLUDE_DIRS  : list of paths to be used with INCLUDE_DIRECTORIES
#   TPCCondData_LIBRARY_DIR  : list of paths to be used with LINK_DIRECTORIES
#
# @author Christian Grefe, CERN
# @author Oliver Schaefer, DESY
##############################################################################

SET( TPCCondData_ROOT "/Users/proj/cdc/soft/MarlinTPC/v01-06/tpcconddata" )
SET( TPCCondData_VERSION "1.6.0" )

# ---------- libraries --------------------------------------------------------
# do not store find results in cache
if(TRUE)
    SET( TPCCondData_INCLUDE_DIRS "${TPCCondData_ROOT}/include" )
else()
    SET( TPCCondData_INCLUDE_DIRS "${TPCCondData_ROOT}/include/TPCCondData" )    
endif()

# Find the TPCCondData libraries
find_library(TPCCondData_LIBRARIES
  NAMES TPCCondData
    PATHS "${TPCCondData_ROOT}/lib"
)

MARK_AS_ADVANCED( TPCCondData_INCLUDE_DIRS TPCCondData_LIBRARY_DIRS TPCCondData_LIBRARIES )

INCLUDE( FindPackageHandleStandardArgs )
# set TPCCondData_FOUND to TRUE if all listed variables are TRUE and not empty
FIND_PACKAGE_HANDLE_STANDARD_ARGS( TPCCondData DEFAULT_MSG TPCCondData_ROOT TPCCondData_INCLUDE_DIRS TPCCondData_LIBRARIES )
