/* WeatherConditions.cc
 * $Id$ 
 */

#include "WeatherConditions.h"

namespace tpcconddata{

std::string WeatherConditions::getRevision() {
    return std::string("$Rev: 1592 $");
}

std::string WeatherConditions::getDefaultColName() {
    return std::string("TPCWeatherConditions");
}

WeatherConditions::WeatherConditions(){
    setTemperature( 0 );
    setPressure( 0 );
    setRelHumidity( 0 );
}

WeatherConditions::~WeatherConditions(){ ; }

float WeatherConditions::getTemperature() const {
    return getFloatVal( 0 );
}

float WeatherConditions::getPressure() const {
    return getFloatVal( 1 );
}

float WeatherConditions::getRelHumidity() const {
    return getFloatVal( 2 );
}

void WeatherConditions::setTemperature( float Value ){
    obj()->setFloatVal( 0, Value);
}

void WeatherConditions::setPressure( float Value ){
    obj()->setFloatVal( 1, Value);
}

void WeatherConditions::setRelHumidity( float Value ){
    obj()->setFloatVal( 2, Value);
}

void WeatherConditions::print( std::ostream& os ) const {

    os<<"temperature:   "<<getTemperature()<<" C"<<std::endl;
    os<<"pressure:      "<<getPressure()<<" hPa"<<std::endl;
    os<<"rel. humidity: "<<getRelHumidity()<<" %"<<std::endl;
}

std::ostream &operator<<(std::ostream &os, const WeatherConditions &wc) {
    wc.print(os);
    return os;
}

}
