#!/bin/bash
# This test executes the 
# examples/reconstruction_multi_module/reconstruction_tracks.xml
# steering files and checks if Marlin runs through without errors.
echo MARLINTPC_SOURCE_DIR is ${MARLINTPC_SOURCE_DIR}
echo MARLINTPC_BIN_DIR is ${MARLINTPC_BIN_DIR}
echo MARLIN_DLL is ${MARLIN_DLL}

echo Marlin is ${MARLIN_BIN_DIR}/Marlin

TEST_DIRECTORY=test_reco_multiModule_TrackMakingKalmanFilter

mkdir ${TEST_DIRECTORY}
cd ${TEST_DIRECTORY} 

#Generate the input data
cp ${MARLINTPC_SOURCE_DIR}/examples/reconstruction_multi_module/gear_LP_TPC_GEM_7module.xml .
${MARLINTPC_BIN_DIR}/generateHelix gear_LP_TPC_GEM_7module.xml
if [ $? -ne 0 ]; then
    echo generateHelix did not succeed
    exit 1
fi

${MARLIN_BIN_DIR}/Marlin ${MARLINTPC_SOURCE_DIR}/examples/reconstruction_multi_module/reconstruction_tracks.xml
if [ $? -ne 0 ]; then
    echo Marlin reconstruction_tracks.xml did not succeed
    exit 2
fi

#only clean up if there was no error, otherwise leave the directory for debugging
cd ..
rm -rf  ${TEST_DIRECTORY}

exit 0
