#ifndef DUMP_N_TRACKS_PROCESSOR_H
#define DUMP_N_TRACKS_PROCESSOR_H 1

//LCIO
#include <lcio.h>

//MARLIN
#include <marlin/Processor.h>

namespace marlintpc
{

    /** Dump the coordinates of the hits in the tracks.
     *  This is easier to read than the output of dumpevent.
     *  Remember that LCIO::TRBIT_HITS has to be set, so the hits are stored.
     *
     *  @author Martin Killenberg, University of Bonn
     */
    class DumpNTracksProcessor : public marlin::Processor{
			      
    public:
    
	virtual Processor*  newProcessor() { return new DumpNTracksProcessor ; }
    
	DumpNTracksProcessor();

	virtual void init( ) ; 

	virtual void processRunHeader( LCRunHeader * run ) ; 

	virtual void processEvent( LCEvent * evt ) ; 
    
    protected:

     std::string _inputColName ;    ///< the name of the input collection

    };
}

#endif // DUMP_HITS_IN_TRACKS_PROCESSOR_H
