#include "HistogramWidthExtractionTools.h"
#include <iostream>

using namespace marlintpc;

//Testing the functionality of the width extraction tools for a histogram
int main()
{

  TH1F* histo = new TH1F("h_gaus","h_gaus",1000,-5,5);
  histo->FillRandom("gaus",50000);
  
  HistogramWidthExtractionTools *myTool= new HistogramWidthExtractionTools();

  std::cout<<"RMS90:"<<std::endl;
  myTool->Calculate(histo,1);
  std::cout<<"Width: "<<myTool->GetWidth()<<" +- "<<myTool->GetWidthError()<<std::endl;
  std::cout<<"Mean: "<<myTool->GetMean()<<" +- "<<myTool->GetMeanError()<<std::endl;
  std::pair<double, double> range =myTool->GetRange();
  std::cout<<"Range: "<<range.first<<" "<<range.second<<std::endl;

  std::cout<<"Fit3Sigma:"<<std::endl;
  myTool->Calculate(histo,2);
  std::cout<<"Width: "<<myTool->GetWidth()<<" +- "<<myTool->GetWidthError()<<std::endl;
  std::cout<<"Mean: "<<myTool->GetMean()<<" +- "<<myTool->GetMeanError()<<std::endl;
  range =myTool->GetRange();
  std::cout<<"Range: "<<range.first<<" "<<range.second<<std::endl;


  std::cout<<"RMS5Sigma:"<<std::endl;
  myTool->Calculate(histo,3);
  std::cout<<"Width: "<<myTool->GetWidth()<<" +- "<<myTool->GetWidthError()<<std::endl;
  std::cout<<"Mean: "<<myTool->GetMean()<<" +- "<<myTool->GetMeanError()<<std::endl;
  range =myTool->GetRange();
  std::cout<<"Range: "<<range.first<<" "<<range.second<<std::endl;

}
