#include <stdexcept>
#include <iostream>
#include <cmath>
#include <complex>

#include <streamlog/streamlog.h>

#include "IntersectionCalculator.h"


using namespace std;
using namespace marlintpc;


int main()
{
  //std::cout << "This program tests the functionality of the IntersectionCalculator."<<std::endl;

  int testFailed=0;
  //test circle_straightLine
  std::pair<double,double> phi_intersec(0,0); 
  double Radius=1;
  double x0=0, y0=0;
  //3 different track angles
  phi_intersec= IntersectionCalculator::circle_straightLine(Radius, x0,y0,0);
  //  cout<<"Phi=0 -> (0,180): "<<phi_intersec.first*180./M_PI<<" "<<phi_intersec.second*180./M_PI<<endl;
  if(fabs(phi_intersec.first*180./M_PI-0)>1e-13 || fabs(phi_intersec.second*180./M_PI-180)>1e-13)
    {
      cout<<"IntersectionCalculator::circle_straightLine(1, 0,0,0) failed!"<<endl;
      testFailed++;
    }
  
  phi_intersec= IntersectionCalculator::circle_straightLine(Radius, x0,y0,M_PI/4);  
  //  cout<<"Phi=45 -> (-135,45): "<<phi_intersec.first*180./M_PI<<" "<<phi_intersec.second*180./M_PI<<endl; 
  if(fabs(phi_intersec.first*180./M_PI-(-135))>1e-13 || fabs(phi_intersec.second*180./M_PI-45)>1e-13)
    {
      cout<<"IntersectionCalculator::circle_straightLine(1, 0,0,45) failed!"<<endl;
      testFailed++;
    }
  
  phi_intersec= IntersectionCalculator::circle_straightLine(Radius, x0,y0,M_PI/2);
  //  cout<<"Phi=90 -> (-90,90): "<<phi_intersec.first*180./M_PI<<" "<<phi_intersec.second*180./M_PI<<endl;
  if(fabs(phi_intersec.first*180./M_PI-(-90))>1e-13 || fabs(phi_intersec.second*180./M_PI-90)>1e-13)
    {
      cout<<"IntersectionCalculator::circle_straightLine(1, 0,0,90) failed!"<<endl;
      testFailed++;
    }

  phi_intersec= IntersectionCalculator::circle_straightLine(Radius, x0,y0,3*M_PI/4);
  //  cout<<"Phi=135 -> (-45,135): "<<phi_intersec.first*180./M_PI<<" "<<phi_intersec.second*180./M_PI<<endl;
  if(fabs(phi_intersec.first*180./M_PI-(-45))>1e-13 || fabs(phi_intersec.second*180./M_PI-135)>1e-13)
    {
      cout<<"IntersectionCalculator::circle_straightLine(1, 0,0,135) failed!"<<endl;
      testFailed++;
    }
  
  //test circle_circle
  //  phi_intersec= IntersectionCalculator::circle_circle(Radius, xm_l, ym_l,fabs(1. / distanceParameter._TrackOmega.at(0)));
  return testFailed;	  
}
